//===========================================================================
//
//	HomeWork from Belgium			Not licensed software  
//	1999 - 2000						No rights reserved
//
//===========================================================================
//
//	Project/Product :	Iconizer DLL
//  FileName		:	TrayIcon.cpp
//	Author(s)		:	Bart Gysens
//
//	Description		:	Implementation of CTrayIcon class
//
//	Classes			:	CTrayIcon
//
//	Information		:
//	  Compiler(s)	:	Visual C++ 6.0 SP4
//	  Target(s)		:	Windows NT and Windows 2000
//	  Editor		:	Visual C++ 6.0 internal editor
//
//	History
//	Vers.  Date      Aut.  Type     Description
//  -----  --------  ----  -------  -----------------------------------------
//	1.00   06 09 00  BG    Create   Original
//
//===========================================================================

#include "stdafx.h"
#include "stdio.h"
#include "shellapi.h"
#include "resource.h"
#include "trayicon.h"

//===========================================================================
//	Externals
//===========================================================================

extern HINSTANCE	g_hModule	;
extern UINT			g_WmTray	;
extern LONG DoGetWindowLong( HWND hWnd, int nIndex );

//===========================================================================
//	Macros and typedefs
//===========================================================================

#define MSG_MENU_ABOUT		( 0xFFFF )
#define TXT_ABOUT			( TEXT( "About Iconizer..." ) )
#define TXT_AUTHORS			( TEXT( "   I  C  O  N  I  Z  E  R    V  E  R     1"	\
								    "\n\nAuthor:\t\tMail:"							\
									"\nBart Gysens\tbgysens@tijd.com"				\
									"\n\n    -- Don't pay for this software --"		) )


//===========================================================================
// 
//	Class			:	CTrayIcon
//	Author(s)		:	Bart Gysens
//
//	Description		:	Implementation of the CTrayIcon class
//
//	Comments		:	none
//
//	History			:	1.00  : Create
//
//===========================================================================

CTrayIcon::CTrayIcon()
{
}

CTrayIcon::~CTrayIcon()
{
}

void CTrayIcon::AddTrayIcon( HWND hWnd )
{
	char	msg[300];
	DWORD	x = 0xFFFFFFFF;

	strcpy( msg, TXT_AUTHORS );
	for ( UINT i=0; i<strlen( msg ); i++ )
		x = ( i % 2 ) ? ( x - msg[i] ) : ( x + msg[i] );
	// if ( ( x % 0xFFFFFE1C ) ) for V 1 . 0 0
	if ( x % 0xFFFFFE2E )
		::MessageBox( NULL, "Choose how to crash your system...", "Don't steal my proud!", MB_ABORTRETRYIGNORE | MB_SYSTEMMODAL );
	TrayMessage( hWnd, NIM_ADD );
}

void CTrayIcon::DelTrayIcon( HWND hWnd )
{
	TrayMessage( hWnd, NIM_DELETE );
}

void CTrayIcon::OnNotifyIcon( HWND hWnd, WPARAM wParam, LPARAM lParam, CHookItem * pItem )
{
	switch( lParam )
	{
		case WM_RBUTTONDOWN:
			{
				HMENU		 hMenu;
				POINT		 pPos ;
				MENUITEMINFO mItem;
				UINT		 uCmd ;			

				// Get cursor position
				GetCursorPos( &pPos );
				
				// Get system menu
				hMenu = GetSystemMenu( hWnd, FALSE );
				
				// Ensure that restore menu item is enabled
				EnableMenuItem( hMenu, SC_RESTORE, MF_BYCOMMAND | MF_ENABLED );

				// Add separtor menu item
				mItem.cbSize		= sizeof( MENUITEMINFO );
				mItem.fMask			= MIIM_TYPE;
				mItem.fType			= MFT_SEPARATOR;
				mItem.fState		= MFS_ENABLED;
				mItem.wID			= 0xFFFD;
				mItem.hSubMenu		= NULL;
				mItem.hbmpChecked	= NULL;
				mItem.hbmpUnchecked = NULL;
				mItem.dwItemData    = 0;
				mItem.dwTypeData    = 0;
				mItem.cch           = 0;
				InsertMenuItem( hMenu, GetMenuItemCount( hMenu ), TRUE, &mItem );

				// Add "About Iconizer..." item
				mItem.cbSize		= sizeof( MENUITEMINFO );
				mItem.fMask			= MIIM_ID | MIIM_STATE | MIIM_TYPE;
				mItem.fType			= MFT_STRING;
				mItem.fState		= MFS_ENABLED;
				mItem.wID			= MSG_MENU_ABOUT;
				mItem.hSubMenu		= NULL;
				mItem.hbmpChecked	= NULL;
				mItem.hbmpUnchecked = NULL;
				mItem.dwItemData    = 0;
				mItem.dwTypeData    = TXT_ABOUT;
				mItem.cch           = strlen( TXT_ABOUT );
				InsertMenuItem( hMenu, GetMenuItemCount( hMenu ), TRUE, &mItem );

				// Show system menu, and execute system command if necessary

				//
				// Remark: Bug fix on TrackPopupMenuEx
				// 1. Set window as foreground window
				// 2. Call TrackPopupMenuEx
				// 3. Post a WM_NULL message
				//
				// => Normal behavior should be a single call to TrackPopupMenuEx

				//
				// TODO: Major problem
				// The menu of the notifyicon is not up-to-date, i.e.
				// sometime the Restore command is disabled!
				//

				SetForegroundWindow( hWnd );
				if ( ( uCmd = TrackPopupMenuEx( hMenu,
							  				    TPM_RETURNCMD | TPM_LEFTBUTTON, 
												pPos.x, 
												pPos.y, 
												hWnd,
												NULL ) ) != 0 )
				{
					// Execute user selected command
					switch( uCmd )
					{
						case MSG_MENU_ABOUT:
							MessageBox( NULL, TXT_AUTHORS, TXT_ABOUT, MB_OK );
							break;

						case SC_MINIMIZE:
							CTrayIcon::DelTrayIcon( hWnd );
							ShowWindow( hWnd, SW_SHOW );
							break;
							
						case SC_MAXIMIZE:
							CTrayIcon::DelTrayIcon( hWnd );
							ShowWindow( hWnd, SW_SHOW );
							ShowWindow( hWnd, SW_MAXIMIZE );
							break;
							
						case SC_RESTORE:	
							CTrayIcon::DelTrayIcon( hWnd );
							ShowWindow( hWnd, SW_SHOW );
							ShowWindow( hWnd, SW_RESTORE );
							break;
							
						case SC_CLOSE:
							CTrayIcon::DelTrayIcon( hWnd );
							ShowWindow( hWnd, SW_SHOW );
							SendMessage( hWnd, WM_SYSCOMMAND, uCmd, 0 );
							break;											

						default:
							// Delete tray icon, make window visible and restore it
							CTrayIcon::DelTrayIcon( hWnd );
							ShowWindow( hWnd, SW_SHOW );
							SendMessage( hWnd, WM_SYSCOMMAND, SC_RESTORE, 0 );

							// Execute user selected command
							SendMessage( hWnd, WM_SYSCOMMAND, uCmd, 0 );
							break;
					}					
				}

				PostMessage( hWnd, WM_NULL, 0, 0 );

				// Delete added menu items
				DeleteMenu( hMenu, GetMenuItemCount( hMenu ) - 1, MF_BYPOSITION );
				DeleteMenu( hMenu, GetMenuItemCount( hMenu ) - 1, MF_BYPOSITION );
			}
			break;

		case WM_LBUTTONDOWN:
			// Restore window
			pItem->m_bIconized = FALSE;
			CTrayIcon::DelTrayIcon( hWnd );
			ShowWindow( hWnd, SW_SHOW );
			SendMessage( hWnd, WM_SYSCOMMAND, SC_RESTORE, 0 );			
			break;

		default:
			break;
	}
}

BOOL CTrayIcon::TrayMessage( HWND hWnd, DWORD dMsg )
{
	// Get an icon handle
	HICON hIcon;
	if ( ( hIcon = (HICON) GetClassLong( hWnd, GCL_HICON ) ) == NULL )
		hIcon = LoadIcon( NULL, IDI_WINLOGO );

	// Create tray icon
	if ( ::IsWindowUnicode( hWnd ) )
	{
		NOTIFYICONDATAW	Icon;
		
		Icon.cbSize				= sizeof( NOTIFYICONDATAW );
		Icon.hWnd				= hWnd;
		Icon.uID				= 0;
		Icon.uFlags				= NIF_MESSAGE | NIF_ICON | NIF_TIP;
		Icon.uCallbackMessage	= g_WmTray;
		Icon.hIcon				= hIcon;
		GetWindowTextW( hWnd, Icon.szTip, sizeof( Icon.szTip ) / 2 );
		return Shell_NotifyIconW( dMsg, &Icon );
	}
	else
	{
		NOTIFYICONDATAA	Icon;
		
		Icon.cbSize				= sizeof( NOTIFYICONDATAA );
		Icon.hWnd				= hWnd;
		Icon.uID				= 0;
		Icon.uFlags				= NIF_MESSAGE | NIF_ICON | NIF_TIP;
		Icon.uCallbackMessage	= g_WmTray;
		Icon.hIcon				= hIcon;		
		GetWindowTextA( hWnd, Icon.szTip, sizeof( Icon.szTip ) );
		return Shell_NotifyIconA( dMsg, &Icon );
	}
}
